'$INCLUDE: '..\include\Declare.bi'
TYPE RegType
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
END TYPE
TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE
DECLARE SUB INTERRUPT (intnum AS INTEGER, inreg AS RegType, outreg AS RegType)
DECLARE SUB INTERRUPTX (intnum AS INTEGER, inreg AS RegTypeX, outreg AS RegTypeX)
DECLARE SUB ABSOLUTE (address AS INTEGER)
DECLARE SUB INT86OLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)
DECLARE SUB INT86XOLD (intnum AS INTEGER, inarray() AS INTEGER, outarray() AS INTEGER)

DIM SHARED inreg AS RegTypeX, outreg AS RegTypeX

DEFINT A-Z
FUNCTION GetCurDir$
'-----------Remember current drive--------
   inreg.ax = &H1900
   CALL INTERRUPTX(&H21, inreg, outreg)
   cd = (outreg.ax AND 255) + 1
'-----------Get drives--------

'cd = 4
DIM Buffer(128)

aseg = VARSEG(Buffer(0))
aptr = VARPTR(Buffer(0))

inreg.ax = &H4700
inreg.dx = cd
inreg.ds = aseg
inreg.si = aptr
CALL INTERRUPTX(&H21, inreg, outreg)
IF outreg.ax = 15 THEN
ERROR 68       'no such drive
ELSE
DEF SEG = aseg
FOR A = 0 TO 128
f$ = f$ + CHR$(PEEK(aptr + A))
NEXT
DEF SEG
s$ = CHR$(cd + 64) + ":\" + LEFT$(f$, INSTR(f$, CHR$(0)) - 1)
IF LEFT$(s$, 1) <> "\" THEN s$ = s$ + "\"
GetCurDir$ = s$
END IF

END FUNCTION

SUB GetDirs (Directory$, Array)
ClearArray Array
inreg.cx = 16 + 1 + 2 + 4 + 128 + 64'(215)
inreg.ax = &H4E00
FMask$ = Directory$ + "*.*" + CHR$(0)
inreg.ds = SSEG(FMask$)
inreg.dx = SADD(FMask$)
CALL INTERRUPTX(&H21, inreg, outreg)
'IF OutReg.flags AND (OutReg.ax = 2 OR OutReg.ax = &H12) THEN EXIT SUB '᫨ a  -  室.
con = 1
DO
inreg.ax = &H2F00
CALL INTERRUPTX(&H21, inreg, outreg)
DEF SEG = outreg.es
FileName$ = ""
FOR i = &H1E TO &H2A
symbol$ = CHR$(PEEK(outreg.bx + i))
IF symbol$ = CHR$(0) THEN EXIT FOR
FileName$ = FileName$ + symbol$
NEXT
IF FileName$ <> "." THEN

dirs$ = UCASE$(FileName$)
CALL putarrs(Array, con, dirs$)
con = con + 1
END IF
inreg.ax = &H4F00
inreg.cx = 215
CALL INTERRUPTX(&H21, inreg, outreg)
LOOP UNTIL (outreg.flags AND (outreg.ax = 2 OR outreg.ax = &H12))


END SUB

SUB GetDrives (Array)
ClearArray Array

'-----------Remember current drive--------
     inreg.ax = &H1900
          CALL INTERRUPTX(&H21, inreg, outreg)
          cd = (outreg.ax AND 255)
          '-----------Get drives--------
k = 1
FOR i = 1 TO 25
        DrNumber = i
    IF DrNumber >= 0 AND DrNumber <= 25 THEN
      inreg.ax = &HE00
      inreg.dx = DrNumber
   
      CALL INTERRUPTX(&H21, inreg, outreg)
      inreg.ax = &H1900
     CALL INTERRUPTX(&H21, inreg, outreg)
      IF DrNumber <> (outreg.ax AND 255) THEN
        'PRINT
      ELSE
      'PRINT "Drive "; DrNumber; " Exists"
      c$ = CHR$(i + 64) + ":\"
      IF c$ <> "B:\" THEN
      'Drives(k) = c$
      putarrs Array, k, c$
      k = k + 1
      END IF
      END IF
 
    END IF
NEXT
'-----------Return current drive--------
      inreg.ax = &HE00
            inreg.dx = cd
                  CALL INTERRUPTX(&H21, inreg, outreg)


END SUB

SUB GetFiles (Directory$, Array, Mask$)
ClearArray Array
s$ = DIR$(Directory$ + Mask$)
CALL putarrs(Array, 1, s$)
i = 1
DO UNTIL s$ = ""
i = i + 1
s$ = DIR$
CALL putarrs(Array, i, s$)
LOOP

END SUB

FUNCTION GetMyName$

  inreg.ax = &H6200
  INTERRUPTX &H21, inreg, outreg
  PSPStart% = outreg.bx

  DEF SEG = PSPStart%
  EnvironStart% = PEEK(&H2D) * 256 + PEEK(&H2C)
  DEF SEG

  DEF SEG = EnvironStart%
  DO
    Char = PEEK(A)
    IF Char = 0 THEN
      A = A + 1
      Char = PEEK(A)
      IF Char = 0 THEN
        Found = 1
      END IF
    END IF
    A = A + 1
  LOOP UNTIL Found = 1
  A = A + 2
  Found = False
  DO
    Char = PEEK(A)
    IF Char = 0 THEN
      Found = 1
    ELSE
      Path$ = Path$ + CHR$(Char)
    END IF
    A = A + 1
  LOOP UNTIL Found = 1
  DEF SEG
  GetMyName$ = Path$


END FUNCTION

FUNCTION isdiskready (Drive$)
IF LEN(Drive$) = 0 THEN EXIT FUNCTION
Dr = ASC(UCASE$(MID$(Drive$, 1, 1))) - 64
inreg.ax = &H1C00
 inreg.dx = Dr
 INTERRUPTX &H21, inreg, outreg
 IF outreg.bx = 0 THEN
 isdiskready = 0
 ELSE
    isdiskready = NOT (0)     'Ready
 END IF





END FUNCTION

SUB splitPath (Path$, Drive$, Dire$, file$, ext$)
s$ = Path$
LL = LEN(s$)
l = LL
IF l < 1 THEN EXIT SUB
'------------------------------------

FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = "." THEN
extl = LL - i + 1
ext$ = RIGHT$(s$, extl)
l = i - 1
EXIT FOR
END IF
NEXT
'-----------------------------------
FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = "\" THEN
file$ = MID$(s$, i + 1, l - i)
filel = l - i - 1
l = i
EXIT FOR
END IF
NEXT
IF (filel = 0) AND (LL > extl) THEN
file$ = LEFT$(s$, l)
filel = LEN(file$)
END IF

'---------------------------

FOR i = l TO 1 STEP -1
D$ = MID$(s$, i, 1)
IF D$ = ":" THEN
Dire$ = MID$(s$, i + 2, l - i - 1)
Drive$ = LEFT$(s$, i + 1)
pathl = l - i - 1
l = i
EXIT FOR
END IF
NEXT

IF (pathl = 0) AND (LL > extl + filel) AND (MID$(s$, l, 1) <> ":") THEN
Dire$ = LEFT$(s$, l)

END IF
'-----------------------------------


END SUB

